#!/usr/bin/perl
###
$MaxTitle=150;
$MaxName=30;
$MaxContent=5000;
$MaxRes=100;
$MaxLog=100;
$MaxThread=1000;
$LinkTarget=" target='_blank' rel='nofollow'";
###
if($ENV{'CONTENT_LENGTH'}){
	read(STDIN,$FORM,$ENV{'CONTENT_LENGTH'});
}else{
	$FORM=$ENV{'QUERY_STRING'};
}
$CMD=&read_value($FORM,"CMD");
$STYLE=&read_value($FORM,"STYLE") || 0;
$STYLE=0 if($STYLE=~/\// || $STYLE=~/^\./);
&read_style;
###
&check_write if($CMD eq "WRITE" || $CMD eq "MAKE");
###
&print_html(&write_thread) if($CMD eq "WRITE");
&print_html(&make_thread) if($CMD eq "MAKE");
&print_html(&list_file);
###
###
sub convert_name{
	my($name,@line);
	$name=&url_unescape(&read_value($FORM,"NAME"));
	open(FILE,"name.dat");
	while(<FILE>){
		@line=split(/<>/);
		if($line[0] eq "IP" && $ENV{REMOTE_ADDR}=~/^$line[1]$/){
			$line[2]=~s/\$NAME/$name/;
			$name=$line[2];
			last;
		}
		if($line[0] eq "NAME" && $name=~/^$line[1]$/){
			$line[2]=~s/\$NAME/$name/;
			$name=$line[2];
			last;
		}
	}
	close(FILE);
	return($name);
}
###
sub check_last{
	my($last);
	open(FILE,"last.dat");
	$last=<FILE>;
	close(FILE);
	&print_html(&list_file("Ž񤭹ɻߵǽƯޤ")) if($last eq $FORM);
	open(FILE,"+>last.dat");
	print FILE $FORM;
	close(FILE);
	return;
}
###
sub convert_content{
	my($str);
	$str=&url_unescape(&read_value($FORM,"CONTENT"));
	$str=" $str";
	$str=~s/\r//g;
	$str=~s/&/&amp;/g;
	$str=~s/ /&nbsp;/g;
	$str=~s/</<&lt;/g;
	$str=~s/>/>&gt;/g;
	$str=~s/(<&lt;[iI][mM][gG]&nbsp;[^>]+)>&gt;/&check_img($1)/eg;
	$str=~s/([^\'])(http:\/\/[\w\!\#\$\%\&\'\(\)\=\-\~\^\|\\\@\{\[\+\;\*\:\}\],\.\/\?\_]+)/$1.&auto_link($2)/eg;
	$str=~s/>&gt;>&gt;(\d+)/<a href="#$1">>&gt;&gt;$1<\/a>/g;
	$str=~s/<&lt;/&lt;/g;
	$str=~s/>&gt;/&gt;/g;
	$str=~s/^&nbsp;//;
	$str=~s/\n+$//;
	$str=~s/\n/<br>/g;
	return($str);
}
###
sub auto_link{
	my($href)=$_[0];
	my($text)=$_[0];
	$href=~s/&amp;/&/g;
	$href=~s/&nbsp;;/&/g;
	return("<a href='$href'$LinkTarget>$text<\/a>");
}
###
sub check_img{
	my($src,$width,$height,@buf,@line);
	@buf=split(/&nbsp;/,$_[0]);
	$width=160;
	$height=120;
	foreach(@buf){
		@line=split(/=/,$_,2);
		$src=$line[1] if($line[0]=~/^[sS][rR][cC]$/);
		$width=$line[1] if($line[0]=~/^[wW][iI][dD][tT][hH]$/);
		$height=$line[1] if($line[0]=~/^[hH][eE][iI][gG][hH][tT]$/);
	}
	$src=~s/[\'\"]//g;
	$src=~s/&amp;/&/g;
	return($_[0].">&gt;") if(!$src);
	$width=~s/[\'\"]//g;
	$height=~s/[\'\"]//g;
	$width=160 if($width=~/[^\d]/);
	$height=120 if($height=~/[^\d]/);
	if($width>320){
		$height=int($height/$width*320);
		$width=320;
	}
	if($height>240){
		$width=int($width/$height*240);
		$height=240;
	}
	$width=1 if(!$width);
	$height=1 if(!$height);
	return("<a href='$src'$LinkTarget><img src='$src' width='$width' height='$height' border='0'><\/a>");
}
###
sub check_write{
	my($name,$content,@file,@line,$form);
	$name=&read_value($FORM,"NAME");
	$content=&read_value($FORM,"CONTENT");
	&record_log($name,$content);
	$name=&url_unescape($name);
	$content=&url_unescape($content);
	&print_html(&list_file("̾Ĺޤ")) if(length($name)>$MaxName);
	&print_html(&list_file("ƤƤ")) if(!$content);
	&print_html(&list_file("ƤĹޤ")) if(length($content)>$MaxContent);
	$form=&url_unescape($FORM);
	open(FILE,"filter.dat");
	@file=<FILE>;
	close(FILE);
	for(@file){
		s/[\r\n]//;
		@line=split(/=/,$_,2);
		if($line[0] eq "I"){
			$line[1]=~s/\./\\\./g;
			$line[1]=~s/\*/\.\*/g;
			&print_html(&list_file("񤭹ߤػߤƤIPɥ쥹Ǥ")) if($ENV{'REMOTE_ADDR'}=~/^$line[1]$/);
		}elsif($line[0] eq "S"){
			&print_html(&list_file("񤭹ߤػߤƤʸ󤬴ޤޤƤޤ")) if($form=~/$line[1]/);
		}
	}
	&check_last;
	return;
}
###
sub record_log{
	my(@log,$name,$content);
	$name=shift;
	$content=shift;
	open(FILE,">>log.dat");
	print FILE "$ENV{REMOTE_ADDR}<>${\(time)}<>$name<>$content\n";
	close(FILE);
	open(FILE,"log.dat");
	@log=<FILE>;
	close(FILE);
	splice(@log,0,int($#log/2)) if($#log>$MaxLog);
	open(FILE,"+>log.dat");
	foreach(@log){
		print FILE;
	}
	close(FILE);
	return;
}
###
sub write_thread{
	my($thread,$name,$content,$number,$html,$res,@time,$time,$i);
	$thread=$_[0] || &read_value($FORM,"THREAD");
	die('error') if($thread=~/\// || $thread=~/^\./);
	$name=&convert_name;
	$content=&convert_content;
	@time=localtime;
	$time[5]-=100;
	$time[4]++;
	for($i=1;$i<6;$i++){
		$time[$i]="0".$time[$i] if(length($time[$i])==1);
	}
	$time="$time[5]/$time[4]/$time[3] $time[2]:$time[1]";
	open(FILE,"thread/0/$thread.html");
	while(<FILE>){
		if(/<!--(\d+)-->/){
			$number=$1 if($number<$1);
		}
	}
	close(FILE);
	$number++;
	&print_html(&list_file("쥹ʤΤǽ񤭹ޤ")) if($number>$MaxRes);
	for($i=0;-e("thread/$i/$thread.html");$i++){
		&read_style($i);
		$html="";
		$res=&make_html("res",$number,$name,$time,$content);
		open(FILE,"thread/$i/$thread.html");
		while(<FILE>){
			s/<!--NEXT-->/$res/;
			$html.=$_;
		}
		close(FILE);
		open(FILE,"+>thread/$i/$thread.html");
		print FILE $html;
		close(FILE);
	}
	&read_style;
	return(&print_location($thread));
}
###
sub make_thread{
	my($view,$title,$html,$i,$style,$number);
	$title=&url_unescape(&read_value($FORM,"TITLE"));
	$title=~s/ +$//;
	$view=$title;
	$title=&base64_encode($title);
	$view=~s/&/&amp;/g;
	$view=~s/</&lt;/g;
	$view=~s/>/&gt;/g;
	$view=~s/</&nbsp;/g;
	&print_html(&list_file("å̾ꤷƤ")) if(!$title);
	&print_html(&list_file("å̾Ĺޤ")) if(length($title)>$MaxTitle);
	$number=1;
	while(-e("thread/0/$title.$number.html")){
		$number++;
	}
	for($i=0;-d("thread/$i");$i++){
		opendir(DIR,"thread/$i");
		@dir=sort {-M("thread/$i/$b")<=>-M("thread/$i/$a")} readdir(DIR);
		closedir(DIR);
		while($#dir>$MaxThread){
			$file=shift(@dir);
			next if($file=~/^\./);
			unlink("thread/$i/$file");
		}
		&read_style($i);
		$html=&make_html("thread","$title.$number",$view);
		open(FILE,"+>thread/$i/$title.$number.html");
		print FILE $html;
		close(FILE);
		chmod(0644,"thread/$i/$title.$number.html");
	}
	&read_style;
	return(&write_thread("$title.$number"));
}
###
sub list_file{
	my(@dir,@list,$i,$j,$content,$thread,$name,@time,$index,$menu,$error,$start);
	$error="<font color='red'>$_[0]</font><br><br>" if($_[0]);
	$index=&read_value($FORM,"INDEX") || 0;
	opendir(DIR,"thread/$STYLE");
	@dir=readdir(DIR);
	closedir(DIR);
	foreach(@dir){
		push(@list,$_) if(/\.html$/);
	}
	@list=sort {-M("thread/$STYLE/$a") <=> -M("thread/$STYLE/$b")} @list;
	if($index>0){
		$menu.="<a href='./?INDEX=${\($index-1)}&STYLE=$STYLE'>&lt;&lt;</a>";
	}else{
		$menu.="&lt;&lt;";
	}
	$start=$index-5;
	$start=0 if($start<0);
	$menu.="<a href='./?STYLE=$STYLE'>&nbsp;1&nbsp;</a>..." if($start!=0);
	for($i=$start;$i<$start+10 && $list[$i*20];$i++){
		if($i==$index){
			$menu.="&nbsp;".($i+1)."&nbsp;";
		}else{
			$menu.="<a href='./?INDEX=$i&STYLE=$STYLE'>&nbsp;".($i+1)."&nbsp;</a>";
		}
	}
	$menu.="...<a href='./?INDEX=${\(int($#list/20))}&STYLE=$STYLE'>&nbsp;".(int($#list/20)+1)."&nbsp;</a>" if($list[($start+10)*20]);
	if($list[($index+1)*20]){
		$menu.="<a href='./?INDEX=${\($index+1)}&STYLE=$STYLE'>&gt;&gt;</a>";
	}else{
		$menu.="&gt;&gt;";
	}
	$content.="$menu<br><br><table>";
	for($i=$index*20;$i<($index+1)*20 && $list[$i];$i++){
		$thread=$list[$i];
		($name,)=split(/\./,$thread);
		$name=&base64_decode($name);
		$name=~s/&/&amp;/g;
		$name=~s/</&lt;/g;
		$name=~s/>/&gt;/g;
		$name=~s/ /&nbsp;/g;
		@time=localtime((stat("thread/$STYLE/$thread"))[9]);
		$time[5]-=100;
		$time[4]+=1;
		for($j=1;$j<6;$j++){
			$time[$j]="0".$time[$j] if(length($time[$j])==1);
		}
		if(-M("thread/$STYLE/$thread")<10){
			$content.="<tr><td style='font-size:xx-small;color:red'>";
		}else{
			$content.="<tr><td style='font-size:xx-small'>";
		}
		$content.="<td><a href='thread/$STYLE/$thread'>$name</a><br><td>&nbsp;&nbsp;(".$time[5]."/".$time[4]."/".$time[3]." ".$time[2].":".$time[1].")<br>\n";
	}
	$content.="</table><br>$menu<br>";
	return(&make_html("list",$content,$error));
}
###
sub read_style{
	my(@dir,$style);
	$style=($_[0] ne '')?$_[0]:$STYLE;
	opendir(DIR,"style/$style");
	@dir=readdir(DIR);
	closedir(DIR);
	foreach(@dir){
		if(/^(\w+)\.dat$/){
			$HTML{$1}="";
			open(FILE,"style/$style/$1.dat");
			while(<FILE>){
				$HTML{$1}.=$_;
			}
			close(FILE);
		}
	}
}
###
sub make_html{
	my($result);
	$result=$HTML{$_[0]};
	$result=~s/\$SCRIPT\((\d+)\)/$_[$1]/g;
	return($result);
}
###
sub read_value{
	my(@objects);
	@objects=split(/[&; ]/,$_[0]);
	foreach(@objects){
		return($1) if(/^$_[1]=(.+)$/);
	}
	return;
}
###
sub url_unescape{
	my($str,$head);
	$str=$_[0];
	$head=$_[1] || '%';
	$head='' if($head==1);
	$str=~tr/+/ /;
	$str=~s/$head([0-9A-Fa-f][0-9A-Fa-f])/pack("H2",$1)/eg;
	return($str);
}
###
sub base64_encode{
	my($in,$out,$table,$temp);
	$in=shift;
	$table="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";
	$in=unpack("B*",$in);
	while(length($in)%6){
		$in.='0';
	}
	while(($temp=substr($in,0,6,'')) ne ''){
		$out.=substr($table,((substr($temp,-6,1))*32)+((substr($temp,-5,1))*16)+((substr($temp,-4,1))*8)+((substr($temp,-3,1))*4)+((substr($temp,-2,1))*2)+(substr($temp,-1,1)),1);
	}
#	while(length($out)%4){
#		$out.='=';
#	}
	return($out);
}
###
sub base64_decode{
	my($in,$out,$table,@temp);
	$in=shift;
	$table="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";
#	$in=~s/=+$//;
	while(($temp[0]=substr($in,0,1,'')) ne ''){
		$temp[0]=index($table,$temp[0]);
		$temp[1]='';
		for($i=0;$i<6;$i++){
			$temp[1].=$temp[0]%2;
			$temp[0]=$temp[0]/2;
		}
		$out.=reverse($temp[1]);
	}
	while(length($out)%8){
		substr($out,-1,1,'');
	}
	$out=pack("B*",$out);
	return($out);
}
###
sub print_html{
	print "content-type:text/html\n\n$_[0]";
	exit;
}
###
sub print_location{
	print "Location:thread/$STYLE/$_[0].html\n\n";
	exit;
}
###
